import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.Vector;

public class CollectionTest {
	public static void main(String[] args) {
		Person[] people = {new Person("K", 10), new Person("S", 20), new Person("P", 30), new Person("S", 20), new Student("KSP", 40, 100)};

		Vector<Person> pVector = new Vector<Person>();
		List<Person> pList = new ArrayList<Person>();
		List<Person> pLinkedList = new LinkedList<Person>();
		Set<Person> pSet = new HashSet<Person>();
		Map<Person, Integer> pMap = new HashMap<Person, Integer>();
		
		for (int i = 0; i < people.length; i++) {
			pVector.add(people[i]);
			pList.add(people[i]);
			pLinkedList.add(people[i]);
			pSet.add(people[i]);
			pMap.put(people[i], i);
		}
		pVector.add(1, new Student("KSP", 40, 200)); // insert
		pList.add(1, new Student("KSP", 40, 200)); // insert
		pLinkedList.add(1, new Student("KSP", 40, 200)); // insert
		pSet.add(new Student("KSP", 40, 100)); // insert the same element
		pMap.put(new Student("KSP", 40, 100), 10); // insert the same element

		System.out.println("pVector");
		pVector.forEach(p -> System.out.println(p));		
		System.out.println("pList");
		pList.forEach(p -> System.out.println(p));		
		System.out.println("pLinkedList");
		pLinkedList.forEach(p -> System.out.println(p));		
		System.out.println("pSet");
		pSet.forEach(p -> System.out.println(p));
		System.out.println("pMap");
		for (Map.Entry<Person,Integer> e : pMap.entrySet()) {
			System.out.println(e.getKey() + "," + e.getValue());	
		}
		
		pVector.sort(null);
		pList.sort(null);
		pLinkedList.sort(null);
		System.out.println("\npVector sorted by default (name)");
		pVector.forEach(p -> System.out.println(p));		
		System.out.println("\npList sorted by default (name)");
		pList.forEach(p -> System.out.println(p));		
		System.out.println("\npLinkedList sorted by default (name)");
		pLinkedList.forEach(p -> System.out.println(p));		
		
		pVector.sort(new AgeComparator());
		pList.sort(new AgeComparator());
		pLinkedList.sort(new AgeComparator());
		System.out.println("\npVector sorted by age");
		pVector.forEach(p -> System.out.println(p));		
		System.out.println("\npList sorted by age");
		pList.forEach(p -> System.out.println(p));		
		System.out.println("\npLinkedList sorted by age");
		pLinkedList.forEach(p -> System.out.println(p));		

		pVector.sort(new IDComparator());
		pList.sort(new IDComparator());
		pLinkedList.sort(new IDComparator());
		System.out.println("\npVector sorted by id");
		pVector.forEach(p -> System.out.println(p));		
		System.out.println("\npList sorted by id");
		pList.forEach(p -> System.out.println(p));		
		System.out.println("\npLinkedList sorted by id");
		pLinkedList.forEach(p -> System.out.println(p));		
		
		Collections.reverse(pVector); // reverse
		Collections.reverse(pList); // reverse
		Collections.reverse(pLinkedList); // reverse
		System.out.println("\npVector reverse");
		pVector.forEach(p -> System.out.println(p));		
		System.out.println("\npList reverse");
		pList.forEach(p -> System.out.println(p));		
		System.out.println("\npLinkedList reverse");
		pLinkedList.forEach(p -> System.out.println(p));		
	
		int index = Collections.binarySearch(pList, new Person("P", 30)); 
		System.out.println("\n Person P 30 index is " + index);
	}
}
