import java.util.Objects;

public class Person implements Comparable<Person> {
    protected String name;    // instance variables
    protected int age;        // instance variables

    public Person() {
    	this("", 0);
    }

    public Person(Person other) {
        this(other.name, other.age);
    }

    public Person(String name, int age) {
        set(name, age);
    }
    
    public void set(Person other) {
        this.name = other.name;
        this.age = other.age;
    }

    public void set(String name, int age) {
        this.name = name;
        this.age = age;
    }
    
    // Object.equals(Object) overriding
    @Override
    public boolean equals(Object other) {                            
        if (other instanceof Person) {
          Person that = (Person) other;
          return this.name.equals(that.name) && this.age == that.age;
        }
        return false;
    }
    
    // Object.hashCode() overriding
    @Override 
    public int hashCode() {
        return Objects.hash(name, age);
    }

    // Object.toString() overriding
	@Override
	public String toString() {
		return "Person [name=" + name + ", age=" + age + "]";
	}

	@Override
    public int compareTo(Person other) {  
      return this.name.compareTo(other.name); //ascending order
      //return otherName.compareTo(thisName); //descending order
    }
}
