import java.util.Comparator;
import java.util.Objects;

public class Student extends Person {
	protected int id;

	public Student() {
		this("", 0, 333);
	}

    public Student(String name, int age, int id) {
        super(name, age);
        this.id = id;
    }

    @Override // Object.equals overriding
    public boolean equals(Object other) {
        if (other instanceof Student) {
          Student that = (Student) other;
          return this.name.equals(that.name) && this.age == that.age && this.id == that.id;
        }
        return false;
    }
	    
    @Override 
    public int hashCode() {
        return Objects.hash(name, age, id);
    }

    @Override
	public String toString() {
		return "Student [id=" + id + ", name=" + name + ", age=" + age + "]";
	}

	public void set(String name, int age, int id) {
        super.set(name, age);
        this.id = id;
    }
	    
    public void set(Student other) {
        this.set(other.name, other.age, other.id);
    }
	    
    public void set(Person other) {
    	if (other instanceof Person)
    		super.set(other);
    	else
    		this.set((Student)other);
    }
}
